# $Id: deriv2f.r,v 1.3 2005/07/21 00:05:32 rolf Exp rolf $
subroutine deriv2f(fy,xlam,y,ymiss,dmat,kstate,npar,nphi,d1f,d2f)
implicit double precision(a-h,o-z)
integer ymiss
dimension fy(kstate), xlam(kstate), dmat(nphi,kstate)
dimension d1f(kstate,npar), d2f(kstate,npar,npar)

zero = 0.d0
do i = 1,kstate {
	do j = 1,npar {
		do k = 1,npar {
			d2f(i,j,k) = zero
		}
	}
}
if(ymiss > 0) return

one = 1.d0
np  = kstate*(kstate-1)
do i = 1,kstate {
	do j = 1,nphi {
		do k = 1,nphi {
			dlamj = xlam(i)*dmat(j,i)
			dlamk = xlam(i)*dmat(k,i)
			d2lam = xlam(i)*dmat(j,i)*dmat(k,i)
			c1    = (y/xlam(i)-one)
			c2    = y/xlam(i)**2
			xx    = d1f(i,j+np)*dlamk+fy(i)*d2lam
			yy    = dlamj*dlamk*fy(i)
			d2f(i,j+np,k+np) = c1*xx-c2*yy
		}
	}
}

return
end
