# $Id: getgl.r,v 1.3 2016/03/15 06:05:19 rolf Exp rolf $
subroutine getgl(fy,xlam,y,ymiss,dmat,nind,tpm,xispd,d1pi,kstate,n,
                 nphi,npar,d1p,d1f,alpha,alphw,a,aw,xlc)
implicit double precision(a-h,o-z)

integer ymiss(n)
dimension fy(kstate,n), xlam(kstate,n), y(n), dmat(nphi,nind)
dimension tpm(kstate,kstate), xispd(kstate)
dimension d1pi(kstate,npar), d1p(kstate,kstate,npar)
dimension d1f(kstate,npar), alpha(kstate), alphw(kstate)
dimension a(kstate,npar), aw(kstate,npar), xlc(n)

# Set zero.
zero = 0.d0

# Initialize; i.e. do the t = 1 case:
call deriv1f(fy(1,1),xlam(1,1),y(1),ymiss(1),dmat(1,1),nind,kstate,npar,nphi,d1f)
sxlc = zero
do j = 1,kstate {
	alpha(j) = xispd(j)*fy(j,1)
	sxlc = sxlc + alpha(j)
	do k1 = 1,npar {
		a(j,k1) = xispd(j)*d1f(j,k1) + fy(j,1)*d1pi(j,k1)
	}
}
xlc(1) = sxlc

do j = 1,kstate {
	alpha(j) = alpha(j)/sxlc
}

if(n>1) {
do kt = 2,n {
	kstart = 1+(kt-1)*kstate
	call deriv1f(fy(1,kt),xlam(1,kt),y(kt),ymiss(kt),dmat(1,kstart),
                     nind,kstate,npar,nphi,d1f)
# Do the a's:
	do j = 1,kstate {
		do k = 1,npar {
			xxx = zero
			yyy = zero
			zzz = zero
			do i = 1, kstate {
				xxx = xxx + alpha(i)*d1p(i,j,k)
				yyy = yyy + a(i,k)*tpm(i,j)
				zzz = zzz + alpha(i)*tpm(i,j)
			}
			aw(j,k) = fy(j,kt)*(xxx + yyy/sxlc) + d1f(j,k)*zzz
		}
	}
	do j = 1,kstate {
		do k = 1,npar {
			a(j,k) = aw(j,k)
		}
	}

# Do the alpha's:
	sxlc = zero
	do j = 1,kstate {
		alphw(j) = zero
		do i = 1,kstate {
			alphw(j) = alphw(j) + alpha(i)*tpm(i,j)
		}
		alphw(j) = fy(j,kt)*alphw(j)
		sxlc = sxlc + alphw(j)
	}
	xlc(kt) = sxlc
	do j = 1,kstate {
		alpha(j) = alphw(j)/sxlc
	}
}
}

return
end
