# $Id: states.r,v 1.3 2016/03/15 06:07:50 rolf Exp rolf $
subroutine states(n,k,iseed,ns,xi,probs,kit)
implicit double precision(a-h,o-z)
dimension ns(n), xi(k,k,n), probs(k)

kit = -1
# Set up the probabilities for the first state:
do i = 1,k {
	probs(i) = 0.
	do j = 1,k {
		probs(i) = probs(i) + xi(i,j,1)
	}
}

# Generate the first state:
call xrf(probs,k,iseed,nst)
if(nst < 0) {
	kit = 1
	return
}
ns(1) = nst

# Run through, generating the 2nd through n-th states:
do kt = 2,n {
# Set up the probabilities:
	ddd = 0.
	do j = 1,k {
		probs(j) = xi(ns(kt-1),j,kt-1)
		ddd = ddd+probs(j)
	}
# Normalize the probabilities:
	do j = 1,k {
		probs(j) = probs(j)/ddd
	}

# Generate the kt-th state:
	call xrf(probs,k,iseed,nst)
	if(nst < 0) {
		kit = kt
		return
	}
	ns(kt) = nst
}

return
end
